/* Copyright (C) 1989 Aladdin Enterprises.  All rights reserved.
   Distributed by Free Software Foundation, Inc.

This file is part of Ghostscript.

Ghostscript is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
to anyone for the consequences of using it or for whether it serves any
particular purpose or works at all, unless he says so in writing.  Refer
to the Ghostscript General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
Ghostscript, but only under the conditions described in the Ghostscript
General Public License.  A copy of this license is supposed to have been
given to you along with Ghostscript so you can know your rights and
responsibilities.  It should be in a file named COPYING.  Among other
things, the copyright notice and this notice must be preserved on all
copies.  */

/* sstorei.h */
/* Fast assignment macros */

/* See store.h for a discussion of the purpose of the following. */

/* Here is where we check for getting around Turbo C's inefficiencies. */
#ifdef __MSDOS__
#  pragma inline
#  define s_store_b(pto,ito,pfrom,ifrom)\
   {	asm les bx,dword ptr pfrom;\
	asm mov ax,es:[bx+((ifrom)*8)]; asm mov cx,es:[bx+((ifrom)*8)+2];\
	asm mov dx,es:[bx+((ifrom)*8)+4]; asm push es:[bx+((ifrom)*8)+6];\
	asm les bx,dword ptr pto;\
	asm mov es:[bx+((ito)*8)],ax; asm mov es:[bx+((ito)*8)+2],cx;\
	asm mov es:[bx+((ito)*8)+4],dx; asm pop es:[bx+((ito)*8)+6];\
   }
#  define s_store_i(pto,pfrom) s_store_b(pto,0,pfrom,0)
#else
	/* s_store_i and s_store_b are simple assignment */
#  define s_store_i(pto,pfrom) (*(pto) = *(pfrom))
#  define s_store_b(pto,ito,pfrom,ifrom) ((pto)[ito] = (pfrom)[ifrom])
#endif
